var WpSaioApp = function(){
    var self = this;
    var $ = jQuery;

    var app_name = '.wp-saio-app';
    var app_el = $(app_name);
    var fields_wrap = $('.wp_saio_fields_wrap');

    var btn_remove_name = '.wpsaio-btn-remove';
    var btn_remove_el = $('.wpsaio-btn-remove');
    /*
     * Init function
     */
    
    self.init = function()
    {
        app_el.find('a').click(function(event) {
            var $this = $(this);
            var parent = $this.closest(app_name);            
            var app_type = parent.data('type');
            if (!fields_wrap.find('div[data-type="' + app_type + '"]').length) {

                $.each(JSON.parse(wp_saio_object.wp_saio_html_inputs), function(index, el) {
                    if (index == app_type) {
                        fields_wrap.append(el);
                    }
                });

                parent.addClass('added');
            }
            return false;                  
        });

        $(document).on('click', btn_remove_name, function(event) {
            if (confirm(wp_saio_object.are_you_sure)) {
                var be_removed = $(this).closest('.wpsaio-app-input-wrap');
                $('.wp_saio_panel_wrap').find('div[data-type="' + be_removed.data('type') + '"]').removeClass('added');
                be_removed.remove();
                $('body').trigger({'type' : 'wp_saio_app_removed'});
            }            
        });
        $('.wp_saio_fields_wrap').sortable({
            'handle': '.wpsaio-btn-move',
            'placeholder': 'wpsaio-app-input-wrap-placeholder',
        });

        $('.wp_saio_colorpicker').wpColorPicker();

        $('.wp_saio_choose_image_btn').click(function(event) {
            self.renderMediaUploader($(this).data('target'));
        });
        //$('.wp_saio_fields_wrap').disableSelection();
    };
    self.renderMediaUploader = function(target)
    {
        'use strict';
        var file_frame;
            
        // If the media frame already exists, reopen it.
        if ( undefined !== file_frame ) {
            file_frame.open();
            return;
        }

        // Create a new media frame
        file_frame = wp.media({
            title: wp_saio_object.add_media_text_title,
            button: {
                text: wp_saio_object.add_media_text_button,
            },
            multiple: false
        });
        // When an image is selected in the media frame...
        file_frame.on('select', function() {
     
            var selection = file_frame.state().get('selection');                
            selection.map( function( attachment ) {                                    
                attachment = attachment.toJSON();
                //console.log(attachment);
                if ( attachment.id ) {
                    var file_choosed = attachment.url;
                    $(target).val(file_choosed);
                }                
            });
        });
        file_frame.open();
    }
};


jQuery(document).ready(function($) {
    var wp_saio_app = new WpSaioApp();
    wp_saio_app.init();
});