<?php
class WpSaioShortcodes
{
    private static $_instance = null;

    public function __construct()
    {
        $apps = WpSaio::defaultApps();
        foreach ($apps as $k => $v) {
            if (isset($v['shortcode']) && !empty($v['shortcode'])) {
                $func = str_replace('-', '', $k);
                add_shortcode($v['shortcode'], array($this, $func . 'Shortcode'));
            }
        }
    }
    public static function instance()
    {
        if (is_null(self::$_instance)) {
            self::$_instance = new self();
        }
        return self::$_instance;
    }
    public function facebookmessengerShortcode($atts)
    {
        ob_start();
        $atts = shortcode_atts(array(
            'url' => '',
        ), $atts);
        $atts = extract($atts);
        ?>
        <div class="nt-aio-popup nt-aio-messenger-popup" id="nt-aio-popup-facebook-messenger">
            <div class="nt-aio-popup-header">
                <div class="nt-aio-popup-title">
                    <div class="nt-aio-popup-title-icon"></div>
                    <!-- /.nt-aio-popup-title-icon -->
                    <div class="nt-aio-popup-title-txt"><?php _e('Messenger', WP_SAIO_LANG_PREFIX); ?></div>
                    <!-- /.nt-aio-popup-title-txt -->
                </div>
                <!-- /.nt-aio-popup-title -->
                <div class="nt-aio-popup-close js__nt_aio_close_popup"></div>
                <!-- /.nt-aio-popup-close -->
            </div>
            <!-- /.nt-aio-popup-header -->
            <div class="nt-aio-popup-content">
                <iframe wh-src="fbIframeURL" style="border:none; border-radius: 0 0 16px 16px; overflow:hidden" scrolling="no" allowtransparency="true" src="https://www.facebook.com/plugins/page.php?href=<?php echo esc_url($url); ?>&amp;tabs=messages&amp;small_header=true&amp;width=300&amp;height=300&amp;adapt_container_width=true&amp;hide_cover=true&amp;show_facepile=false&amp;appId" width="300" height="300" frameborder="0"></iframe>
            </div>
            <!-- /.nt-aio-popup-content -->
        </div>
        <!-- /#nt-aio-popup-facebook-messenger.nt-aio-popup nt-aio-messenger-popup -->
        <?php
        return ob_get_clean();
    }
    public function whatsappShortcode($atts)
    {
        ob_start();
        $atts = shortcode_atts(array(
            'phone' => '',
        ), $atts);
        $atts = extract($atts);
        ?>
        <div class="nt-aio-popup nt-aio-whatsapp-popup" id="nt-aio-popup-whatsapp">
            <div class="nt-aio-popup-header">
                <div class="nt-aio-popup-title">
                    <div class="nt-aio-popup-title-icon"></div>
                    <!-- /.nt-aio-popup-title-icon -->
                    <div class="nt-aio-popup-title-txt"><?php _e('Whatsapp', WP_SAIO_LANG_PREFIX); ?></div>
                    <!-- /.nt-aio-popup-title-txt -->
                </div>
                <!-- /.nt-aio-popup-title -->
                <div class="nt-aio-popup-close js__nt_aio_close_popup"></div>
                <!-- /.nt-aio-popup-close -->
            </div>
            <!-- /.nt-aio-popup-header -->
            <div class="nt-aio-popup-content">
                <p><?php _e('Add the number to the Contacts on your phone and send us a message via app.', WP_SAIO_LANG_PREFIX); ?></p>
                <p><?php _e('Call us:', WP_SAIO_LANG_PREFIX); ?></p>
                <h2><?php echo $phone; ?></h2>
            </div>
            <!-- /.nt-aio-popup-content -->
        </div>
        <!-- /#nt-aio-popup-whatsapp.nt-aio-popup nt-aio-whatsapp-popup -->
        <?php
        return ob_get_clean();
    }
    public function snapchatShortcode($atts)
    {
        ob_start();
        $atts = shortcode_atts(array(
            'username' => '',
        ), $atts);
        $atts = extract($atts);
        ?>
        <div class="nt-aio-popup nt-aio-snapchat-popup" id="nt-aio-popup-snapchat">
            <div class="nt-aio-popup-header">
                <div class="nt-aio-popup-title">
                    <div class="nt-aio-popup-title-icon"></div>
                    <!-- /.nt-aio-popup-title-icon -->
                    <div class="nt-aio-popup-title-txt"><?php _e('Snapchat', WP_SAIO_LANG_PREFIX); ?></div>
                    <!-- /.nt-aio-popup-title-txt -->
                </div>
                <!-- /.nt-aio-popup-title -->
                <div class="nt-aio-popup-close js__nt_aio_close_popup"></div>
                <!-- /.nt-aio-popup-close -->
            </div>
            <!-- /.nt-aio-popup-header -->
            <div class="nt-aio-popup-content">
               <div class="content-snapchat-qrcode" wh-html="snapchatQRCode"><object data="https://feelinsonice-hrd.appspot.com/web/deeplink/snapcode?username=<?php echo $username; ?>&amp;type=PNG" type="image/png" width="200px" height="200px"></object></div>
               <div class="content-snapchat-name" wh-html-unsafe="snapchatUser"><?php echo $username; ?></div>
            </div>
            <!-- /.nt-aio-popup-content -->
        </div>
        <!-- /#nt-aio-popup-snapchat.nt-aio-popup nt-aio-snapchat-popup -->
        <?php
        return ob_get_clean();
    }
    public function lineShortcode($atts)
    {
        ob_start();
        $atts = shortcode_atts(array(
            'url' => '',
        ), $atts);
        $atts = extract($atts);
        ?>
        <div class="nt-aio-popup nt-aio-line-popup" id="nt-aio-popup-line">
            <div class="nt-aio-popup-header">
                <div class="nt-aio-popup-title">
                    <div class="nt-aio-popup-title-icon"></div>
                    <!-- /.nt-aio-popup-title-icon -->
                    <div class="nt-aio-popup-title-txt"><?php _e('Line', WP_SAIO_LANG_PREFIX); ?></div>
                    <!-- /.nt-aio-popup-title-txt -->
                </div>
                <!-- /.nt-aio-popup-title -->
                <div class="nt-aio-popup-close js__nt_aio_close_popup"></div>
                <!-- /.nt-aio-popup-close -->
            </div>
            <!-- /.nt-aio-popup-header -->
            <div class="nt-aio-popup-content">
                <iframe wh-src="lineIframeURL" scrolling="no" allowtransparency="true" src="<?php echo $url; ?>" frameborder="0"></iframe>
            </div>
            <!-- /.nt-aio-popup-content -->
        </div>
        <?php
        return ob_get_clean();
    }
    public function viberShortcode($atts)
    {
        ob_start();
        $atts = shortcode_atts(array(
            'account' => '',
        ), $atts);
        $atts = extract($atts);
        ?>
        <div class="nt-aio-popup nt-aio-viber-popup" id="nt-aio-popup-viber">
            <div class="nt-aio-popup-header">
                <div class="nt-aio-popup-title">
                    <div class="nt-aio-popup-title-icon"></div>
                    <!-- /.nt-aio-popup-title-icon -->
                    <div class="nt-aio-popup-title-txt"><?php _e('Viber', WP_SAIO_LANG_PREFIX); ?></div>
                    <!-- /.nt-aio-popup-title-txt -->
                </div>
                <!-- /.nt-aio-popup-title -->
                <div class="nt-aio-popup-close js__nt_aio_close_popup"></div>
                <!-- /.nt-aio-popup-close -->
            </div>
            <!-- /.nt-aio-popup-header -->
            <div class="nt-aio-popup-content">
                <a href="http://chats.viber.com/<?php echo $account; ?>" 
                onclick="window.open(this.href,'targetWindow', 'toolbar=no, location=no, status=no, menubar=no, scrollbars=yes, resizable=yes, width=800, height=800'); return false;"
                ><?php echo $account; ?></a>                
            </div>
            <!-- /.nt-aio-popup-content -->
        </div>
        <?php
        return ob_get_clean();
    }
    public function phoneShortcode($atts)
    {
        ob_start();
        $atts = shortcode_atts(array(
            'phone_number' => '',
        ), $atts);
        $atts = extract($atts);
        ?>
        <div class="nt-aio-popup nt-aio-phone-popup" id="nt-aio-popup-phone">
            <div class="nt-aio-popup-header">
                <div class="nt-aio-popup-title">
                    <div class="nt-aio-popup-title-icon"></div>
                    <!-- /.nt-aio-popup-title-icon -->
                    <div class="nt-aio-popup-title-txt"><?php _e('Phone', WP_SAIO_LANG_PREFIX); ?></div>
                    <!-- /.nt-aio-popup-title-txt -->
                </div>
                <!-- /.nt-aio-popup-title -->
                <div class="nt-aio-popup-close js__nt_aio_close_popup"></div>
                <!-- /.nt-aio-popup-close -->
            </div>
            <!-- /.nt-aio-popup-header -->
            <div class="nt-aio-popup-content">
                <a href="tel:<?php echo $phone_number; ?>"><?php echo $phone_number; ?></a>
            </div>
            <!-- /.nt-aio-popup-content -->
        </div>
        <?php
        return ob_get_clean();
    }
    public function emailShortcode($atts)
    {
        ob_start();
        $atts = shortcode_atts(array(
            'email' => '',
        ), $atts);
        $atts = extract($atts);
        ?>
        <div class="nt-aio-popup nt-aio-email-popup" id="nt-aio-popup-email">
            <div class="nt-aio-popup-header">
                <div class="nt-aio-popup-title">
                    <div class="nt-aio-popup-title-icon"></div>
                    <!-- /.nt-aio-popup-title-icon -->
                    <div class="nt-aio-popup-title-txt"><?php _e('Email', WP_SAIO_LANG_PREFIX); ?></div>
                    <!-- /.nt-aio-popup-title-txt -->
                </div>
                <!-- /.nt-aio-popup-title -->
                <div class="nt-aio-popup-close js__nt_aio_close_popup"></div>
                <!-- /.nt-aio-popup-close -->
            </div>
            <!-- /.nt-aio-popup-header -->
            <div class="nt-aio-popup-content">
                <a href="mailto:<?php echo $email; ?>"><?php echo $email; ?></a>
            </div>
            <!-- /.nt-aio-popup-content -->
        </div>
        <?php
        return ob_get_clean();
    }
}
